Attribute VB_Name = "basFunzioniTopografiaDeg"

Option Explicit

Public Function AngDirezABDeg(CoordinateStazione As Range, CoordinateTraguardo As Range) As Variant

'Funzione per il calcolo dell'angolo di direzione tra i punti A e B.
'Le coordinate dei punti devono essere presenti in una
'coppia di celle affiancate (su una riga) o sovrapposte (su una colonna)
' xA, yA
' xB, yB
'Il presente codice pu essere utilizzato a scopi didattici
'senza rimuovere le informazioni sull'autore
'Carlo Palatella carlopala@tiscali.it
'http://www.web.tiscali.it/Didattica
'E' escluso qualsiasi uso commerciale.


Dim xA As Double
Dim yA As Double
Dim xB As Double
Dim yB As Double
Dim DeltaX As Double
Dim DeltaY As Double
Dim AngDirez As Double
Dim TangenteAngDirez As Double
Dim PiGreco As Double
PiGreco = Atn(1) * 4


If CoordinateStazione.Rows.Count = 1 Then
    'i valori su una riga
    xA = CoordinateStazione(1, 1)
    yA = CoordinateStazione(1, 2)
End If
If CoordinateStazione.Columns.Count = 1 Then
    'i valori su una colonna
    xA = CoordinateStazione(1, 1)
    yA = CoordinateStazione(2, 1)
End If
If CoordinateTraguardo.Rows.Count = 1 Then
    'i valori su una riga
    xB = CoordinateTraguardo(1, 1)
    yB = CoordinateTraguardo(1, 2)
End If
If CoordinateTraguardo.Columns.Count = 1 Then
    'i valori su una colonna
    xB = CoordinateTraguardo(1, 1)
    yB = CoordinateTraguardo(2, 1)
End If


DeltaX = xB - xA
DeltaY = yB - yA
If DeltaX = 0 And DeltaY = 0 Then
    AngDirezABDeg = "Punti coincidenti!"
    Exit Function
End If
If DeltaY = 0 Then
    If DeltaX > 0 Then
        'asse x positivo
        AngDirez = PiGreco / 2
    Else
        'asse x negativo
        AngDirez = PiGreco * 3 / 2
    End If
End If
If DeltaY > 0 Then
    TangenteAngDirez = DeltaX / DeltaY
    If DeltaX >= 0 Then
        'primo quadrante
        AngDirez = Atn(TangenteAngDirez)
    Else
        'quarto quadrante
        AngDirez = Atn(TangenteAngDirez) + 2 * PiGreco
    End If
End If
If DeltaY < 0 Then
    TangenteAngDirez = DeltaX / DeltaY
    If DeltaX >= 0 Then
        'terzo quadrante
        AngDirez = Atn(TangenteAngDirez) + PiGreco
    Else
        'secondo quadrante
        AngDirez = Atn(TangenteAngDirez) + PiGreco
    End If
End If

AngDirezABDeg = AngDirez / PiGreco * 180
End Function



Public Function SenDeg(Angolo As Double) As Double
'Il presente codice pu essere utilizzato a scopi didattici
'senza rimuovere le informazioni sull'autore
'Carlo Palatella carlopala@tiscali.it
'http://www.web.tiscali.it/Didattica
'E' escluso qualsiasi uso commerciale.

Dim AngoloRad As Double
Dim Angolo90 As Integer
Dim FlagAngolo90 As Boolean
FlagAngolo90 = False
If Angolo / 90 = Int(Angolo / 90) Then
    ' un multiplo di 90
    Angolo90 = Angolo / 90
    FlagAngolo90 = True
End If
If FlagAngolo90 = True And Angolo90 / 2 = Int(Angolo90 / 2) Then
    'Risolve un problema di precisione relativo a 180 e 360
    SenDeg = 0
Else
    AngoloRad = Application.WorksheetFunction.Radians(Angolo)
    SenDeg = Sin(AngoloRad)
End If
End Function
Public Function CosDeg(Angolo As Double) As Double
'Il presente codice pu essere utilizzato a scopi didattici
'senza rimuovere le informazioni sull'autore
'Carlo Palatella carlopala@tiscali.it
'http://www.web.tiscali.it/Didattica
'E' escluso qualsiasi uso commerciale.

Dim AngoloRad As Double
Dim Angolo90 As Integer
Dim FlagAngolo90 As Boolean
FlagAngolo90 = False
If Angolo / 90 = Int(Angolo / 90) Then
    ' un multiplo di 90
    Angolo90 = Angolo / 90
    FlagAngolo90 = True
End If
If FlagAngolo90 = True And Angolo90 / 2 > Int(Angolo90 / 2) Then
    'Risolve un problema di precisione relativo a 90 e 270
    CosDeg = 0
Else
    AngoloRad = Application.WorksheetFunction.Radians(Angolo)
    CosDeg = Cos(AngoloRad)
End If
End Function
Public Function TanDeg(Angolo As Double) As Variant
'Il presente codice pu essere utilizzato a scopi didattici
'senza rimuovere le informazioni sull'autore
'Carlo Palatella carlopala@tiscali.it
'http://www.web.tiscali.it/Didattica
'E' escluso qualsiasi uso commerciale.

Dim AngoloRad As Double
Dim Angolo90 As Integer
Dim FlagAngolo90 As Boolean
FlagAngolo90 = False
If Angolo / 90 = Int(Angolo / 90) Then
    ' un multiplo di 90
    Angolo90 = Angolo / 90
    FlagAngolo90 = True
End If
If FlagAngolo90 = True And Angolo90 / 2 > Int(Angolo90 / 2) Then
    'Asintoto
    TanDeg = "Indeterminato"
Else
    If FlagAngolo90 = True And Angolo90 / 2 = Int(Angolo90 / 2) Then
        'Risolve un problema di precisione per 180 e 360
        TanDeg = 0
    Else
        AngoloRad = Application.WorksheetFunction.Radians(Angolo)
        TanDeg = Tan(AngoloRad)
    End If
End If
End Function

Public Function CoTanDeg(Angolo As Double) As Variant
'Il presente codice pu essere utilizzato a scopi didattici
'senza rimuovere le informazioni sull'autore
'Carlo Palatella carlopala@tiscali.it
'http://www.web.tiscali.it/Didattica
'E' escluso qualsiasi uso commerciale.

Dim AngoloRad As Double
Dim Angolo90 As Integer
Dim FlagAngolo90 As Boolean
FlagAngolo90 = False
If Angolo / 90 = Int(Angolo / 90) Then
    ' un multiplo di 90
    Angolo90 = Angolo / 90
    FlagAngolo90 = True
End If
If FlagAngolo90 = True And Angolo90 / 2 = Int(Angolo90 / 2) Then
    'Asintoto
    CoTanDeg = "Indeterminato"
Else
    If FlagAngolo90 = True And Angolo90 / 2 > Int(Angolo90 / 2) Then
        'Risolve un problema di precisione per 90 e 270
        CoTanDeg = 0
    Else
        AngoloRad = Application.WorksheetFunction.Radians(Angolo)
        CoTanDeg = 1 / Tan(AngoloRad)
    End If
End If
End Function

Public Function ArcSenDeg(Seno As Double) As Double
'Il presente codice pu essere utilizzato a scopi didattici
'senza rimuovere le informazioni sull'autore
'Carlo Palatella carlopala@tiscali.it
'http://www.web.tiscali.it/Didattica
'E' escluso qualsiasi uso commerciale.


Dim Errore
Dim AngoloRad As Double
'Verifica il valore del seno
If Seno > 1 Or Seno < -1 Then
    Errore = MsgBox("Il valore del seno deve essere compreso tra -1 e 1", vbOKOnly, "Errore")
    ArcSenDeg = ""
    Exit Function
End If
AngoloRad = Application.WorksheetFunction.Asin(Seno)
ArcSenDeg = Application.WorksheetFunction.Degrees(AngoloRad)


End Function

Public Function ArcCosDeg(Coseno As Double) As Double
'Il presente codice pu essere utilizzato a scopi didattici
'senza rimuovere le informazioni sull'autore
'Carlo Palatella carlopala@tiscali.it
'http://www.web.tiscali.it/Didattica
'E' escluso qualsiasi uso commerciale.


Dim Errore
Dim AngoloRad As Double
'Verifica il valore del Coseno
If Coseno > 1 Or Coseno < -1 Then
    Errore = MsgBox("Il valore del coseno deve essere compreso tra -1 e 1", vbOKOnly, "Errore")
    ArcCosDeg = ""
    Exit Function
End If
AngoloRad = Application.WorksheetFunction.Acos(Coseno)
ArcCosDeg = Application.WorksheetFunction.Degrees(AngoloRad)


End Function
Public Function ArcTanDeg(Tangente As Double) As Double
'Il presente codice pu essere utilizzato a scopi didattici
'senza rimuovere le informazioni sull'autore
'Carlo Palatella carlopala@tiscali.it
'http://www.web.tiscali.it/Didattica
'E' escluso qualsiasi uso commerciale.

Dim AngoloRad As Double
AngoloRad = Atn(Tangente)
ArcTanDeg = Application.WorksheetFunction.Degrees(AngoloRad)


End Function

Public Function ArcCoTanDeg(Cotangente As Double) As Double
'Il presente codice pu essere utilizzato a scopi didattici
'senza rimuovere le informazioni sull'autore
'Carlo Palatella carlopala@tiscali.it
'http://www.web.tiscali.it/Didattica
'E' escluso qualsiasi uso commerciale.

Dim AngoloRad As Double
Dim Tangente As Double
If Cotangente = 0 Then
    ArcCoTanDeg = 90
    Exit Function
Else
    Tangente = 1 / Cotangente
End If

AngoloRad = Atn(Tangente)
ArcCoTanDeg = Application.WorksheetFunction.Degrees(AngoloRad)


End Function



