Attribute VB_Name = "basFunzioniTopografiaGon"
Option Explicit
Public Function AngDirezABGon(CoordinateStazione As Range, CoordinateTraguardo As Range) As Variant

'Funzione per il calcolo dell'angolo di direzione tra i punti A e B.
'Le coordinate dei punti devono essere presenti in una
'coppia di celle affiancate (su una riga) o sovrapposte (su una colonna)
' xA, yA
' xB, yB
'Il presente codice pu essere utilizzato a scopi didattici
'senza rimuovere le informazioni sull'autore
'Carlo Palatella carlopala@tiscali.it
'http://www.web.tiscali.it/Didattica
'E' escluso qualsiasi uso commerciale.

Dim xA As Double
Dim yA As Double
Dim xB As Double
Dim yB As Double
Dim DeltaX As Double
Dim DeltaY As Double
Dim AngDirez As Double
Dim TangenteAngDirez As Double
Dim PiGreco As Double
PiGreco = Atn(1) * 4


If CoordinateStazione.Rows.Count = 1 Then
    'i valori su una riga
    xA = CoordinateStazione(1, 1)
    yA = CoordinateStazione(1, 2)
End If
If CoordinateStazione.Columns.Count = 1 Then
    'i valori su una colonna
    xA = CoordinateStazione(1, 1)
    yA = CoordinateStazione(2, 1)
End If
If CoordinateTraguardo.Rows.Count = 1 Then
    'i valori su una riga
    xB = CoordinateTraguardo(1, 1)
    yB = CoordinateTraguardo(1, 2)
End If
If CoordinateTraguardo.Columns.Count = 1 Then
    'i valori su una colonna
    xB = CoordinateTraguardo(1, 1)
    yB = CoordinateTraguardo(2, 1)
End If


DeltaX = xB - xA
DeltaY = yB - yA
If DeltaX = 0 And DeltaY = 0 Then
    AngDirezABGon = "Punti coincidenti!"
    Exit Function
End If
If DeltaY = 0 Then
    If DeltaX > 0 Then
        'asse x positivo
        AngDirez = PiGreco / 2
    Else
        'asse x negativo
        AngDirez = PiGreco * 3 / 2
    End If
End If
If DeltaY > 0 Then
    TangenteAngDirez = DeltaX / DeltaY
    If DeltaX >= 0 Then
        'primo quadrante
        AngDirez = Atn(TangenteAngDirez)
    Else
        'quarto quadrante
        AngDirez = Atn(TangenteAngDirez) + 2 * PiGreco
    End If
End If
If DeltaY < 0 Then
    TangenteAngDirez = DeltaX / DeltaY
    If DeltaX >= 0 Then
        'terzo quadrante
        AngDirez = Atn(TangenteAngDirez) + PiGreco
    Else
        'secondo quadrante
        AngDirez = Atn(TangenteAngDirez) + PiGreco
    End If
End If

AngDirezABGon = AngDirez / PiGreco * 200
End Function
Public Function CoTanGon(Angolo As Double) As Variant
'Il presente codice pu essere utilizzato a scopi didattici
'senza rimuovere le informazioni sull'autore
'Carlo Palatella carlopala@tiscali.it
'http://www.web.tiscali.it/Didattica
'E' escluso qualsiasi uso commerciale.

Dim PiGreco As Double
PiGreco = Atn(1) * 4
Dim AngoloRad As Double
Dim Angolo100 As Integer
Dim FlagAngolo100 As Boolean
FlagAngolo100 = False
If Angolo / 100 = Int(Angolo / 100) Then
    ' un multiplo di 100
    Angolo100 = Angolo / 100
    FlagAngolo100 = True
End If
If FlagAngolo100 = True And Angolo100 / 2 = Int(Angolo100 / 2) Then
    'Asintoto
    CoTanGon = "Indeterminato"
Else
    If FlagAngolo100 = True And Angolo100 / 2 > Int(Angolo100 / 2) Then
        'Risolve un problema di precisione per 100 e 300
        CoTanGon = 0
    Else
        AngoloRad = Application.WorksheetFunction.Radians(Angolo * 9 / 10)
        CoTanGon = 1 / Tan(AngoloRad)
    End If
End If
End Function

Public Function TanGon(Angolo As Double) As Variant
'Il presente codice pu essere utilizzato a scopi didattici
'senza rimuovere le informazioni sull'autore
'Carlo Palatella carlopala@tiscali.it
'http://www.web.tiscali.it/Didattica
'E' escluso qualsiasi uso commerciale.

Dim AngoloRad As Double
Dim Angolo100 As Integer
Dim FlagAngolo100 As Boolean
FlagAngolo100 = False
If Angolo / 100 = Int(Angolo / 100) Then
    ' un multiplo di 100
    Angolo100 = Angolo / 100
    FlagAngolo100 = True
End If
If FlagAngolo100 = True And Angolo100 / 2 > Int(Angolo100 / 2) Then
    'Asintoto
    TanGon = "Indeterminato"
Else
    If FlagAngolo100 = True And Angolo100 / 2 = Int(Angolo100 / 2) Then
        'Risolve un problema di precisione per 200 e 400
        TanGon = 0
    Else
        AngoloRad = Application.WorksheetFunction.Radians(Angolo * 9 / 10)
        TanGon = Tan(AngoloRad)
    End If
End If
End Function

Public Function SenGon(Angolo As Double) As Double
'Il presente codice pu essere utilizzato a scopi didattici
'senza rimuovere le informazioni sull'autore
'Carlo Palatella carlopala@tiscali.it
'http://www.web.tiscali.it/Didattica
'E' escluso qualsiasi uso commerciale.

Dim AngoloRad As Double
Dim Angolo100 As Integer
Dim FlagAngolo100 As Boolean
FlagAngolo100 = False


If Angolo / 100 = Int(Angolo / 100) Then
    ' un multiplo di 100
    Angolo100 = Angolo / 100
    FlagAngolo100 = True
End If
If FlagAngolo100 = True And Angolo100 / 2 = Int(Angolo100 / 2) Then
    'Risolve un problema di precisione relativo a 200 e 400
    SenGon = 0
Else
    AngoloRad = Application.WorksheetFunction.Radians(Angolo * 9 / 10)
    SenGon = Sin(AngoloRad)
End If


End Function

Public Function CosGon(Angolo As Double) As Double
'Il presente codice pu essere utilizzato a scopi didattici
'senza rimuovere le informazioni sull'autore
'Carlo Palatella carlopala@tiscali.it
'http://www.web.tiscali.it/Didattica
'E' escluso qualsiasi uso commerciale.

Dim AngoloRad As Double
Dim Angolo100 As Integer
Dim FlagAngolo100 As Boolean
FlagAngolo100 = False

If Angolo / 100 = Int(Angolo / 100) Then
    ' un multiplo di 100
    Angolo100 = Angolo / 100
    FlagAngolo100 = True
End If
If FlagAngolo100 = True And Angolo100 / 2 > Int(Angolo100 / 2) Then
    'Risolve un problema di precisione relativo a 100 e 300
    CosGon = 0
Else
    AngoloRad = Application.WorksheetFunction.Radians(Angolo * 9 / 10)
    CosGon = Cos(AngoloRad)
End If
End Function

Public Function ArcSenGon(Seno As Double) As Double
'Il presente codice pu essere utilizzato a scopi didattici
'senza rimuovere le informazioni sull'autore
'Carlo Palatella carlopala@tiscali.it
'http://www.web.tiscali.it/Didattica
'E' escluso qualsiasi uso commerciale.


Dim Errore
Dim AngoloRad As Double
'Verifica il valore del seno
If Seno > 1 Or Seno < -1 Then
    Errore = MsgBox("Il valore del seno deve essere compreso tra -1 e 1", vbOKOnly, "Errore")
    ArcSenGon = ""
    Exit Function
End If
AngoloRad = Application.WorksheetFunction.Asin(Seno)
ArcSenGon = Application.WorksheetFunction.Degrees(AngoloRad) * 10 / 9


End Function

Public Function ArcCosGon(Coseno As Double) As Double
'Il presente codice pu essere utilizzato a scopi didattici
'senza rimuovere le informazioni sull'autore
'Carlo Palatella carlopala@tiscali.it
'http://www.web.tiscali.it/Didattica
'E' escluso qualsiasi uso commerciale.


Dim Errore
Dim AngoloRad As Double
'Verifica il valore del Coseno
If Coseno > 1 Or Coseno < -1 Then
    Errore = MsgBox("Il valore del coseno deve essere compreso tra -1 e 1", vbOKOnly, "Errore")
    ArcCosGon = ""
    Exit Function
End If
AngoloRad = Application.WorksheetFunction.Acos(Coseno)
ArcCosGon = Application.WorksheetFunction.Degrees(AngoloRad) * 10 / 9


End Function
Public Function ArcTanGon(Tangente As Double) As Double
'Il presente codice pu essere utilizzato a scopi didattici
'senza rimuovere le informazioni sull'autore
'Carlo Palatella carlopala@tiscali.it
'http://www.web.tiscali.it/Didattica
'E' escluso qualsiasi uso commerciale.

Dim AngoloRad As Double
AngoloRad = Atn(Tangente)
ArcTanGon = Application.WorksheetFunction.Degrees(AngoloRad) * 10 / 9


End Function

Public Function ArcCoTanGon(Cotangente As Double) As Double
'Il presente codice pu essere utilizzato a scopi didattici
'senza rimuovere le informazioni sull'autore
'Carlo Palatella carlopala@tiscali.it
'http://www.web.tiscali.it/Didattica
'E' escluso qualsiasi uso commerciale.

Dim AngoloRad As Double
Dim Tangente As Double
If Cotangente = 0 Then
    ArcCoTanGon = 90
    Exit Function
Else
    Tangente = 1 / Cotangente
End If

AngoloRad = Atn(Tangente)
ArcCoTanGon = Application.WorksheetFunction.Degrees(AngoloRad) * 10 / 9


End Function
